package cn.com.ty.lift.system.template.service.impl;

import cn.com.ty.lift.system.template.dao.entity.Item;
import cn.com.ty.lift.system.template.dao.entity.Template;
import cn.com.ty.lift.system.template.dao.entity.model.TemplateReq;
import cn.com.ty.lift.system.template.dao.mapper.TemplateMapper;
import cn.com.ty.lift.system.template.service.ItemService;
import cn.com.ty.lift.system.template.service.TemplateService;
import cn.com.xwy.boot.web.dto.RestResponse;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import lombok.AllArgsConstructor;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 * 模板 服务实现类
 * </p>
 *
 * @author wang-hai-cheng
 * @since 2019-12-06
 */
@Service
@AllArgsConstructor
public class TemplateServiceImpl extends ServiceImpl<TemplateMapper, Template> implements TemplateService {
    private final ItemService itemService;

    public RestResponse removeItemOfTemplate(Long id) {
        if (this.remove(new QueryWrapper<Template>().eq("id", id)) && itemService.remove(new QueryWrapper<Item>().eq("template_id", id))) {
            return RestResponse.ok(null, "1", "删除成功");
        }
        return RestResponse.ok(null, "1", "删除失败");
    }

    public RestResponse getItems(TemplateReq templateReq) {
//        IPage<Item> itemIPage = itemService.page(
//                new Page<>(templateReq.getPageNum(), templateReq.getPageSize()),
//                new QueryWrapper<Item>().eq("template_id", templateReq.getId()));
//        if (itemIPage.getRecords().isEmpty()) {
//            return RestResponse.ok(null, "9", "无数据");
//        }
//        return RestResponse.ok(itemIPage, "1", "查询成功");
        List<Item> items = itemService.list(new QueryWrapper<Item>().eq("template_id", templateReq.getId()));
        if (items.isEmpty()) {
            return RestResponse.ok(null, "9", "无数据");
        }
        return RestResponse.ok(items, "1", "查询成功");
    }

    public RestResponse deleteItem(Item item) {
        Item byId = itemService.getById(item.getId());
        if (this.getById(byId.getTemplateId()).getEdit() != 1) {
            return RestResponse.ok(null, "0", "此模板项无法删除");
        }
        if (itemService.removeById(item.getId())) {
            return RestResponse.ok(null, "1", "删除成功");
        }
        return RestResponse.ok(null, "0", "删除失败");
    }
}
